#++++++++++++++++
#.IDENTIFICATION catr.gawk
#.LANGUAGE       gawk
#.AUTHOR         CDS Catalogues Service
#.ENVIRONMENT    
#.KEYWORDS       
#.VERSION  1.0   03-Apr-1996
#.VERSION  1.1   16-Apr-1996: Keep in array I the catalogues already listed
#			(avoid duplications...)
#.VERSION  1.2   12-Nov-2003: Bug with blank lines
#.VERSION  1.23  24-Jun-2007: mloop added.
#.VERSION  1.3   19-Feb-2009: cat argument (filtering)
#.PURPOSE        RECURSIVE cat.gawk
#.COMMENTS       Argument pgm=   (default /usr/local/bin/qcat)
#----------------
BEGIN {
    if (pgm == "") pgm = "/usr/local/bin/qcat" ;
    mloop = 9999999;	# Max number of loops (V1.2)
}
END { print "" }
/^%I .*=/ {
    if (++iloop > mloop) exit(1);
    i = index($2, "=");
    id2 = substr($2,i+1); 
    while ((substr($0,1,1) == "%") && (iloop<mloop)) { getline ; iloop++ }
    #print "++++Equivalence++++id2=" id2; for (i in I) print "I[" i "]=" I[i] ;
    if (I[id2] > 0)  next ;
    I[id2] += 1 ;
    cmd = pgm " -0 " id2 ;
    i = 0 ; 
    bl = 1 ;		# Blank Lines 
    while ((cmd | getline) > 0) {
	if (++iloop > mloop) exit(1);
	if ($0 == "") bl++; else bl = 0;
	if (bl>1) continue;
	if (substr($0, 1, 1) == "%") i++;
	if (i > 0) print ;
    }
    close(cmd);
}
/^%I / {
    if (++iloop > mloop) exit(1);
    if (I[$2] > 0) {
	while (($0 != "") && (iloop<mloop)) { getline ; iloop++ }
	next
    }
    I[$2] += 1 ;
    bl = 0;		# No Blank Line
}
/^%J=/ { 
    if (++iloop > mloop) exit(1);
    J1 = substr($0,4); gsub(/[+]/, "\\&", J1);
    print "%R " J1;
    bl=0; 
    next
}
{ 
    if (++iloop > mloop) exit(1);
    if ($0 == "") bl++; 
    else bl = 0; 
    if (bl<=1) print
}
