#++++++++++++++++
#.IDENTIFICATION edb0.awk
#.LANGUAGE       gawk
#.AUTHOR         Francois Ochsenbein [CDS]
#.VERSION  1.0   11-Jan-1992
#.VERSION  1.1   05-Jan-1993: %F (list of Files)
#.VERSION  1.2   04-Jul-1995: Edit only first J A ...
#.VERSION  1.3   30-Aug-2009: Date in Vizier
#.PURPOSE        Edit on a single line a catalogue. 
#		Option rm=obsolete to remove Obsolete Catalogues
#----------------
BEGIN { 
  items = "%I%S%T%A%J";
  for (i=1; i<=length(items); i+=2) X[substr(items,i,2)] = "";
  #if (index(rm, "o") != 0)  rmo = 1; else rmo = 0;
}
function out() {
	if (length(I) > 9) printf("%s  %s\n", I, substr(T, 1, 76-length(I)));
	else printf("%-9s %s\n", I, T);
	if (D != "" || S != "") printf("%9s %s\n", S, D);
	if (A != "") printf("          %s\n", A);
	if (J != "") printf("          %s\n", J);
	I = ""
#	printf("%-9s %s\n", X["%I"], X["%T"]);
#	printf("%9s %s\n", X["%S, X["%A"]);
#	printf("          %s\n", X["%J"]);
}
#/^%/  { if ($1 in X) X[$1] = substr($0, 4, len[$1])
/^#  *[(]/ { if (I == "") print; else last_line = $0; next }
/^%I/ { I = $2; next }
/^%S/ { S = substr($0, 4, 9); next }
/^%t/ { T = substr($0, 4, 68); next }
/^%T/ { if (T == "") T = substr($0, 4, 68); next }
/^%A/ { if (A == "") A = substr($0, 4, 68); next }
/^%J=/{ # if (length(J) != 19) J = tr(substr($0,4), "+","&"); 
	next }
/^%J/ { if(J == "") J = substr($0, 4, 68); next }
/^%D/ { if (D == "") {
            i=index($0, "="); if (i<4) i=length; D = substr($0, 4, i-4)
            if(index($NF, "v=JD")>0) { 
	       i=split($NF,a,"="); D = D " (VizieR: " a[i] ")" 
	    }
	}
	if (index($0,"OBSOL") != 0) D = D " =OBSOLETED="
        #D = substr($0, 4); #D = substr($0, 4, 68); 
        #if ((rmo == 1) && (index(D, "OBSOL") != 0))  I = ""; 
	#print "#D=" D
        next }
/^%F/ { if (D == "") D = "(" (NF-1) " files)" }
/^$/  { if (I != "") out();
	I = ""; S = ""; T = ""; A = ""; J = ""; D = "";
      }
END   { if (I!="") out(); if (last_line != "") print last_line }
